%include "wmiinc.inc"
%include "rsrc.inc"

// string equivalent for main menu resource id
%define $wszMainMenu "\L#10000"

extern lstrcpyW
extern lstrcpynW
extern lstrcatW
extern strncatw
extern AllocHeap
extern FreeHeap
extern SizeHeap
extern wmiError
extern SystemError
extern lvInsertColumnW
extern lvInsertItemW
extern lvSetTextW
extern lvAddItemW
extern lvSetDataW
extern ColorListView
extern CreateSleepingTimer ; dwmsWaitTime, callback,data
extern Application_LoadSettings ; hwnd
extern Application_SaveSettings ; hwnd
extern TabSubclassProc
extern $wszTabSubclassProcProp
extern vtType2str
extern isMenuItemChecked ; hMenu, id

SW_SHOW       equ 0x005
SW_HIDE       equ 0x000
IDC_ARROW     equ 32512
WM_INITDIALOG equ 0x110
WM_SETICON    equ 0x080
WM_INITMENUPOPUP equ 0x117
WM_SETCURSOR  equ 0x020
WM_INITMENU   equ 0x116
WM_CLOSE      equ 0x010
WM_USER       equ 0x400
WM_TIMER      equ 0x113
WM_NOTIFY     equ 0x04E
WM_LBUTTONDOWN equ 0x201
WM_MOUSEMOVE   equ 0x200
WM_LBUTTONUP   equ 0x202
WM_GETTEXT    equ 0x00D
WM_COMMAND    equ 0x111
WM_SIZE       equ 0x005
CB_ADDSTRING  equ 0x143
CB_GETLBTEXT  equ 0x148
CB_GETCOUNT equ 0x146
GWL_WNDPROC   equ -4
DWL_MSGRESULT equ 0
MF_DISABLED equ 2
MF_GRAYED   equ 1
WAIT_TIMEOUT  equ 0x102
IDCANCEL      equ 0x002
CBN_SELCHANGE equ 0x001
CB_RESETCONTENT equ 0x14B
CB_FINDSTRINGEXACT equ 0x158
CB_SETCURSEL       equ 0x14E
SB_SETTEXTW     equ WM_USER+11
SBT_NOBORDERS   equ 0x100
LVS_EX_GRIDLINES     equ 0x0001
LVS_EX_FULLROWSELECT equ 0x0020
LVS_EX_LABELTIP      equ 0x4000
LVCFMT_RIGHT         equ 0x1
LVCF_FMT             equ 0x1
LVCF_WIDTH           equ 0x2
LVCF_TEXT            equ 0x4
LVIF_TEXT            equ 1
LVIF_STATE           equ 8
LVIS_SELECTED        equ 2
LVIS_FOCUSED         equ 1
LVM_DELETEALLITEMS   equ 0x1000+9
LVM_SETEXTENDEDLISTVIEWSTYLE equ 0x1000+54
LVM_INSERTITEMW      equ 0x1000+77
LVM_SETITEMSTATE     equ 0x1000 + 43
LVM_GETITEMA         equ 0x1000 + 5
LVM_GETITEMW         equ 0x1000 + 75
LVM_INSERTCOLUMNW    equ 0x1000 + 97
LVM_SETITEMW         equ 0x1000 + 76
LVM_SCROLL           equ 0x1000 + 20
LVM_GETTOPINDEX      equ 0x1000+ 39
LVM_GETITEMCOUNT     equ 0x1004
NM_CUSTOMDRAW        equ -12
UDN_FIRST            equ -721
UDN_DELTAPOS         equ UDN_FIRST-1
ERROR_ALREADY_EXISTS equ 183

GENERIC_WRITE         equ 0x40000000
FILE_SHARE_READ       equ 0x00000001
CREATE_ALWAYS         equ 2
FILE_ATTRIBUTE_NORMAL equ 0x80

TCM_GETITEMCOUNT equ 0x1300 + 4
TCM_INSERTITEM equ 0x1300 + 62
TCM_DELETEALLITEMS equ 0x1300+9
TCIF_TEXT equ 1
TCIF_PARAM equ 8
TCN_SELCHANGE equ -550 - 1
TCM_GETCURSEL equ 0x1300 + 11
TCM_SETCURSEL equ 0x1300 + 12
TCM_GETITEM equ 0x1300 + 60
LVM_GETCOUNTPERPAGE equ 0x1000 + 40
LVM_ENSUREVISIBLE equ 0x1000 + 19
LVM_DELETEITEM equ 0x1008

OFN_ENABLESIZING    equ 0x800000
OFN_EXPLORER        equ 0x080000
OFN_PATHMUSTEXIST   equ 0x000800
OFN_OVERWRITEPROMPT equ 0x000002

struc OPENFILENAME
.lStructSize       resd 1;
.hwndOwner         resd 1;
.hInstance         resd 1;
.lpstrFilter       resd 1;
.lpstrCustomFilter resd 1;
.nMaxCustFilter    resd 1;
.nFilterIndex      resd 1
.lpstrFile         resd 1;
.nMaxFile          resd 1
.lpstrFileTitle    resd 1
.nMaxFileTitle     resd 1
.lpstrInitialDir   resd 1
.lpstrTitle        resd 1
.Flags             resd 1
.nFileOffset       resw 1
.nFileExtension    resw 1
.lpstrDefExt       resd 1
.lCustData         resd 1
.lpfnHook          resd 1
.lpTemplateName    resd 1
endstruc


struc NMHDR
.hwndFrom resd 1
.idFrom resd 1
.code resd 1
endstruc

struc NM_UPDOWN
.hdr resb NMHDR_size
.iPos resd 1
.iDelta resd 1
endstruc

struc FINDREPLACE
.lStructSize resd 1
.hwndOwner resd 1
.hInstance resd 1
.Flags resd 1
.lpstrFindWhat resd 1
.lpstrReplaceWith resd 1
.wFindWhatLen resw 1
.wReplaceWithLen resw 1
.lCustData resd 1
.lpfnHook resd 1
.lpTemplateName resd 1
endstruc

struc LV_COLUMN
.imask resd 1
.fmt resd 1
.lx resd 1
.pszText resd 1
.cchTextMax resd 1
.iSubItem resd 1
endstruc

struc LV_ITEM
.imask resd 1
.iItem resd 1
.iSubItem resd 1
.state resd 1
.stateMask resd 1
.pszText resd 1
.cchTextMax resd 1
.iImage resd 1
.lParam resd 1
endstruc

struc RECT
.left   resd 1
.top    resd 1
.right  resd 1
.bottom resd 1
endstruc

struc TC_ITEM
.mask resd 1
.lpReserved1 resd 1
.lpReserved2 resd 1
.pszText resd 1
.cchTextMax resd 1
.iImage resd 1
.lParam resd 1
endstruc

INTERFACE IErrorInfo
	STDMETHOD QueryInterface
	STDMETHOD AddRef
	STDMETHOD Release
	STDMETHOD GetGUID
	STDMETHOD GetSource
	STDMETHOD GetDescription
	STDMETHOD GetHelpFile
	STDMETHOD GetHelpContext
ENDINTERFACE

// custom structures

struc SPLITTERDATA
.splpos       resd 1
.splstart     resd 1
.hbr          resd 1 ; rect.left
.hbm          resd 1 ; rect.top
.clientW      resd 1 ; rect.right
.clientH      resd 1 ; rect.bottom
endstruc

struc THREADDATA
.hwnd         resd 1
.hThread      resd 1
.pService     resd 1 ; IWbemServices - copy from [$g_pService]
.pError       resd 1 ; 
.pPropEnum    resd 1 ; IEnumWbemClassObject
.pObject      resd 1 ; IWbemClassObject
.lvColorIndex resd 1 ; 
.array        resd 1 ; SAFEARRAY
.bstrClass    resd 1 ; create:ThreadEnumProps(); destroy:ShowMethods(),onEnumPropertiesEnd(),
.showall      resd 1 ; BOOL show not implemented properties
endstruc
extern _IID_IWbemServices

%define WM_USER_ENUM_PROPS_START   WM_USER+3
%define WM_USER_ENUM_PROPS_DONE    WM_USER+4
%define WM_USER_ENUM_CLASSES_DONE  WM_USER+5
%define WM_USER_CLOSEHANDLE        WM_USER+6
%define COMBO_W      180
%define LVS_EX_STYLE LVS_EX_GRIDLINES | LVS_EX_FULLROWSELECT | LVS_EX_LABELTIP
