%include "asm.inc"

global AllocHeap
global FreeHeap
global SizeHeap
extern $g_hHeap

HEAP_ZERO_MEMORY equ 8

AllocHeap: //size
	invoke HeapAlloc, [$g_hHeap], HEAP_ZERO_MEMORY, [esp+4]
	ret 4


FreeHeap: // lpMem
	xor    eax,eax
	invoke HeapFree, [$g_hHeap], eax, [esp+4]
	ret    4


SizeHeap: // lpMem
	xor    eax,eax
	invoke HeapSize, [$g_hHeap], eax, [esp+4]
	ret    4

