%include "asm.inc"

global isMenuItemChecked

struc MENUITEMINFO
.cbSize        resd 1
.fMask         resd 1
.fType         resd 1
.fState        resd 1
.wID           resd 1
.hSubMenu      resd 1
.hbmpChecked   resd 1
.hbmpUnchecked resd 1
.dwItemData    resd 1
.dwTypeData    resd 1
.cch           resd 1
.hbmpItem      resd 1
endstruc

MIIM_STATE equ 1
MFS_CHECKED equ 8

PROC isMenuItemChecked, MENUITEMINFO_size, hMenu, id
	LOCAL mii, MENUITEMINFO_size

.menu:
	lea    esi,mii
	mov    dword[esi+MENUITEMINFO.cbSize],MENUITEMINFO_size
	mov    dword[esi+MENUITEMINFO.fMask],MIIM_STATE
	invoke GetMenuItemInfoW, hMenu,id,0,esi
	mov    eax,[esi+MENUITEMINFO.fState]
	and    eax,MFS_CHECKED
	shr    eax,3
ENDPROC


