%include "wmiinc.inc"

global wmiError
extern AllocHeap
extern FreeHeap

PROC wmiError, 40, title, code

	LOCAL  bstrError
	LOCAL  pError
	LOCAL  hex,32


	%define  STRMAX 512
	%define  NULL   eax
	call     AllocHeap, 512<<1
	mov      esi,eax
	and      eax,eax
	jz       near finito

	invoke   lstrcpyW,esi,title
	invoke   lstrcatW,esi,"\L "

	// The IWbemStatusCodeText::GetErrorCodeText method returns the
	// text string description associated with the error code
	xor      edx,edx
	invoke   CoCreateInstance, _CLSID_WbemStatusCodeText, edx, CLSCTX_INPROC_SERVER, _IID_IWbemStatusCodeText, offset pError
	and      eax,eax
	jnz      nodesc

	xor      edx,edx
	coinvoke pError, IWbemStatusCodeText@GetErrorCodeText, code, edx, edx, offset bstrError
	and      eax,eax
	jnz      release

	invoke   lstrcatW, esi, bstrError
	invoke   SysFreeString, bstrError

release:
	coinvoke pError, IWbemStatusCodeText@Release
	jmp      finito

nodesc:
	lea      edi,hex
	cdecl    swprintf, edi, "\L%X", code
	invoke   lstrcatW, esi, edi
finito:
	mov      eax,esi
ENDPROC
