%include "asm.inc"

global TabSubclassProc
global $wszTabSubclassProcProp

struc NMHDR
.hwndFrom resd 1
.idFrom resd 1
.code resd 1
endstruc


WM_DESTROY   equ 2
WM_NOTIFY    equ 0x04E
WM_HSCROLL   equ 0x114
GWL_WNDPROC  equ -4
UDN_FIRST    equ -721
UDN_DELTAPOS equ UDN_FIRST-1

PROC TabSubclassProc, 4, hwnd, msg, wParam, lParam
	LOCAL lpfn

	invoke GetPropW, hwnd, $wszTabSubclassProcProp
	mov   lpfn,eax

	select msg

		case WM_DESTROY
			invoke SetWindowLongW, GWL_WNDPROC, lpfn
			invoke RemovePropW, hwnd, $wszTabSubclassProcProp

		case WM_NOTIFY
			mov   esi,lParam
			cmp   dword[esi+NMHDR.code],UDN_DELTAPOS
			jne  .sk
			invoke GetParent,hwnd
			invoke SendMessageW,eax,WM_NOTIFY,wParam, lParam
			jmp    .quit
.sk:

	endselect

	invoke CallWindowProcW, lpfn, hwnd, msg, wParam, lParam
.quit:
ENDPROC


segment .data
$wszTabSubclassProcProp db "\LLPFN"
